

/* Bstr_replace.c */

#include "Bstr.h"


static const char *LEER = "";

/* suchw durch replw in line ersetzen, 
   how_much: wie oft, 
   0: so oft wie suchw vorkommt */

char *Bstr_replace(const char *suchw,
                   const char *replw,
                   const char *line,
                   int how_much)
{
  char *sw;
  size_t suchpnt = 0;
  size_t linelen = strlen(line);
  size_t suchwlen = strlen(suchw);
  char *new = (char *) LEER;
  char *o_new,*o_linetemp;
  char *linetemp = Bstr_malloc(linelen + 1);

  how_much = how_much ? how_much : -1;
  strcpy(linetemp, line);
  o_linetemp=linetemp;

  while (suchwlen > 0 &&
         (sw = strstr(linetemp + suchpnt, suchw)) && 
         how_much--)
    {                /* suchwort gefunden */
      sw[0] = '\0';  /* teilstring vor suchw bilden */
      o_new=new;
      new = (char *) 
        pstr_create(o_new, linetemp, replw, (char *)0);

      if(o_new!=LEER) 
        pstr_delete(o_new);
      linetemp = sw + suchwlen;
    }

  o_new = new;
  new = (char *) pstr_create(o_new, linetemp,(char *)0);
  if(o_new!=LEER)
    pstr_delete(o_new);
  pstr_delete(o_linetemp);

  return (new);
}

