

Mai 94

leser

Leserbriefe


/*
   So funktioniert siso.c aus iX 3, 95 auch unter Linux.
   */


#include <sys/types.h>
#include <sys/wait.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>

void application ();

void
main (argc, argv)
     int argc;
     char *argv[];
{
  int sock, msgsock, *stat;
  struct sockaddr_in server;
  sock = socket (AF_INET, SOCK_STREAM, 0);

  server.sin_family = AF_INET;
  server.sin_addr.s_addr = INADDR_ANY;
  /* Convert host byte order to network byte order. Note that
     they are different on Intel-PC's. */
  server.sin_port = htons(atoi (argv[1]));
  if (bind (sock, (struct sockaddr *) &server, sizeof (server)))
    perror ("bind");

  if (listen (sock, 5))
    perror ("listen");

  do {
    msgsock = accept (sock, 0, 0);
    if (msgsock == -1) perror ("accept");
    else
      switch (fork ()) {
      case  0:
        { application (msgsock, argv[2]); break; }
      case -1:
        { perror ("fork"); break; }
      default:
        { close (msgsock); wait (stat); }
      }
  } while (1);
}

void application (com_sock, prog)
     char *prog;
     int com_sock;
{
  close(0);
  close(1);
  close(2);

  if (dup2(com_sock, 0) == -1)
    perror ("dup2");
  if (dup2(com_sock, 1) == -1)
    perror ("dup2");
  if (dup2(com_sock, 2) == -1)
    perror ("dup2");

  /* The second argument of execl is argv[0] of the executed program,
     which is the program-name itself. */
  if (execl (prog, prog, NULL) == -1)
    perror ("execl");
  exit (0);
}
